﻿(function () {
    var demo = window.demo = window.demo || {};
    var collapseTimeOut;
    var expandTimeOut;
    var isMouseOverNode = false;
    var collapseDelay = 300;
    var expandDelay = 500;

    window.OnClientNodeMouseEnter = function (sender, args) {
        var node = args.get_node(),
                  expandedSubling = node.get_parent().get_expandedNode();

        if (node.get_hidden()) {
            return;
        }

        clearTimeout(collapseTimeOut);

        if (node.get_expandedNode()) {
            node.get_expandedNode().collapse();
            return;
        }

        if (expandedSubling && expandedSubling !== node) {
            expandedSubling.collapse(true);
        }

        expandTimeOut = setTimeout(function () {
            if (!node.get_expanded()) {
                node.expand();
            }
        }, expandDelay);

        isMouseOverNode = true;
    };

    window.OnClientNodeMouseLeave = function (sender, args) {
        var $ = $telerik.$,
                  node = args.get_node(),
                  event = args.get_domEvent();

        if (node.get_hidden()) {
            return;
        }

        clearTimeout(expandTimeOut);

        isMouseOverNode = false;

        if ($(event.relatedTarget).closest(node.get_animationContainer()).length > 0) {
            return;
        }

        collapseTimeOut = setTimeout(function () {
            if (!isMouseOverNode) {
                if (sender.get_expandedNode()) {
                    sender.get_expandedNode().collapse();
                }
            }
        }, collapseDelay);
    };

    var data = [
        { ID: 1, ParentID: null, Name: "TV Channels" },
        { ID: 2, ParentID: null, Name: "Sports" },
        { ID: 3, ParentID: null, Name: "Events" },
        { ID: 4, ParentID: 1, Name: "CNN" },
        { ID: 5, ParentID: 1, Name: "NBC" },
        { ID: 6, ParentID: 1, Name: "ABC" },
        { ID: 7, ParentID: 2, Name: "Us Sports" },
        { ID: 8, ParentID: 2, Name: "European Sports" },
        { ID: 9, ParentID: 3, Name: "Oscar Awards" },
        { ID: 10, ParentID: 3, Name: "MTV Movie Awards" },
        { ID: 11, ParentID: 7, Name: "Baseball" },
        { ID: 12, ParentID: 7, Name: "Basketball" },
        { ID: 13, ParentID: 7, Name: "Football" },
        { ID: 14, ParentID: 8, Name: "Soccer" },
        { ID: 15, ParentID: 8, Name: "Volleyball" },
        { ID: 16, ParentID: 8, Name: "Tennis" }
    ];

    window.setData = function (dataSource) {
        dataSource.set_data(data);
    };

})();